// Encoder.h : Declaration of the CEncoder

#ifndef __ENCODER_H_
#define __ENCODER_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CEncoder
class ATL_NO_VTABLE CEncoder : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CEncoder, &CLSID_Encoder>,
	public IEncoder
{
public:
	CEncoder()
	{
		m_Key = 1;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_ENCODER)
DECLARE_NOT_AGGREGATABLE(CEncoder)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CEncoder)
	COM_INTERFACE_ENTRY(IEncoder)
END_COM_MAP()

// IEncoder
public:
	STDMETHOD(get_Key)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_Key)(/*[in]*/ short newVal);
	STDMETHOD(EncodeString)(/*[in]*/ const BSTR instring, /*[out, retval]*/ BSTR * outstring);
protected:
	short m_Key;
};

#endif //__ENCODER_H_
